import { Component, inject, OnInit } from '@angular/core';
import { FormControl, FormGroup, ReactiveFormsModule, Validators } from '@angular/forms';
import { loadStripe, Stripe } from '@stripe/stripe-js';
import { DepositService } from '../service/deposit.service';

@Component({
  selector: 'app-deposit',
  standalone: true,
  imports: [
    ReactiveFormsModule,
  ],
  templateUrl: './deposit.component.html',
  styleUrl: './deposit.component.css'
})
export class DepositComponent implements OnInit{
  protected form = new FormGroup({amount: new FormControl(50, [Validators.min(50)])});
  private stripe: Stripe | null = null;
  private service: DepositService = inject(DepositService);

  async ngOnInit() {
    this.stripe = await loadStripe('pk_test_51QrePYIvCfqz7ANgMizBorPpVjJ8S6gcaL4yvcMQnVaKyReqcQ6jqaQEF7aDZbDu8rNVsTZrw8ABek4ToxQX7KZe00jpGh8naG');
  }

  submit() {
    if (this.stripe) {
      console.log(JSON.stringify(this.form.value.amount as number));
      this.service.handleDeposit(this.form.value.amount as number).subscribe(({sessionId}) => {
        this.stripe?.redirectToCheckout({sessionId});
      });
    }
  }
}
